package com.eactive.eai.batch.job.jobItem.ked;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.common.FileUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KEDBT_0320 extends DefaultTelegram implements TelegramService
{

	private BufferedInputStream bis;
    private int BLOCK_NO;
    private int SEQUENCE_NO;
    private int REAL_BYTE;         // 실 data byte수
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_KEDBT_0320() {
        //DATA송신
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = setBlockAndSeqNO();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션ID - KED 및 회원사에서 업무구분을 위하여 SET하는 문자이다.
             // 회원사에서 KED에 파일 송신시 : “CB02"
            // KED에서 회원사에 파일 송신시 : “RB02"
            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(2, this.getFldTelegramType(), this.al_FieldProps[2]);

            //응답코드 - 전문의 처리결과를 나타내는 코드로 REQUEST전문(지시 및 요구전문)에는 “000”을 SET하며 RESPONSE전문(통보 및 보고전문)에서는 해당내용을 SET한다.
            compileField(3, this.getResolveResponseCode(), this.al_FieldProps[3]);

            //회원사 코드 - 전문을 전송한 기관을 확인하기 위한 회원사 코드 이다.
            compileField(4, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[4]);

            //파일명 - 0600/0610/0800/0810 전문의 경우 Space 처리함
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //BLOCK-NO
            compileField(6, ""+BLOCK_NO, this.al_FieldProps[6]);
            //SEQUENCE-NO
            compileField(7, ""+SEQUENCE_NO, this.al_FieldProps[7]);
            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
            	logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);
            for (int inx = REAL_BYTE; inx < fldLen; inx++) {
                data[inx] = ' ';
            }
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            return fldLen;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<6; i++) { //KED전문의 헤더는 파일명까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=6; i< al_Field.size()-1; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int telegramSize = batchDoc.getBatchMsg().getHeader().getSequenceSize();
        int preFldTotSize = 0;
        for (int i=1; i< idx; i++) {
            byte[] aField = (byte[]) this.al_Field.get(i);
            preFldTotSize += aField.length;
        }

        return telegramSize - preFldTotSize;

    }

    private boolean createFile ()
    {

        bis = BatchOpenFileManager.getInstance().getBis(batchDoc.getBatchMsg().getHeader().getUUID());
        if( bis != null ) return true;
        try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }

            String fileName = fileDir + fileNm;

            File file = new File(fileName);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = fileName;
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                throw new Exception(" the File["+fileName+"] does not exist!!!");
            }
            bis = new BufferedInputStream ( new FileInputStream(file) );
            BatchOpenFileManager.getInstance().addBis(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, bis);
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    private boolean setBlockAndSeqNO ()
    {
        try {
            if (!createFile()) {
            	logger.error("{}  file open failed", logHeader);
                return false;
            }

            int block_size = this.batchDoc.getBatchMsg().getHeader().getBlockSize();
            int block_no = this.batchDoc.getBatchMsg().getBody().getBlockNum();
            int seq_no = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            if (block_no == 0 && seq_no == 0) { //첫 0320 전송이면
                this.BLOCK_NO = 1;
                this.SEQUENCE_NO = 1;
                this.setConditionTxt("");

            } else {
                if (seq_no == block_size) { //한 블럭 송신 후 결번확인(0300) 이후 데이터 전송
                    this.BLOCK_NO = block_no+1;
                    this.SEQUENCE_NO = 1;
                    this.setConditionTxt("");

                } else if (seq_no >= block_size-1) {    //블럭 크기에 도달하면 BLOCKEND 하여 다음 0620전문으로 넘어가게 함
                    this.BLOCK_NO = block_no;
                    this.SEQUENCE_NO = seq_no+1;
                    this.setConditionTxt(TelegramKeys.BLOCKEND);
                } else {            //한 블럭내에 데이터 전송 반복이면
                    this.BLOCK_NO = block_no;
                    this.SEQUENCE_NO = seq_no+1;
                    this.setConditionTxt("");
                }

            }
            // 한번에 블러킹 할 건수
            int seqCnt = ( getCalculatedLength(al_Field.size()-1) / batchDoc.getBatchMsg().getHeader().getRecLen() );
            // 남은 바이트 수
            long remainSize = batchDoc.getBatchMsg().getHeader().getFileSize() - batchDoc.getBatchMsg().getBody().getCurFileSize();
            // 남은 건수
            long remainCnt = remainSize / batchDoc.getBatchMsg().getHeader().getRecLen();

            boolean isLastSeq = false;
            if ( seqCnt < remainCnt ){
                REAL_BYTE = seqCnt * batchDoc.getBatchMsg().getHeader().getRecLen();
            }else{
                REAL_BYTE = (int)remainCnt * batchDoc.getBatchMsg().getHeader().getRecLen();
                this.setConditionTxt(TelegramKeys.BLOCKEND);
                isLastSeq = true;
            }
            int readCnt = REAL_BYTE / batchDoc.getBatchMsg().getHeader().getRecLen();

            fileData = new byte[REAL_BYTE];
            for ( int inx = 0 ; inx < readCnt ; inx++){
                byte[] fileLine = FileUtil.readLine(bis);
                System.arraycopy( fileLine, 0, fileData, inx * batchDoc.getBatchMsg().getHeader().getRecLen(), batchDoc.getBatchMsg().getHeader().getRecLen());
            }

            if ( isLastSeq ){
                bis.close();
                BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID());
            }

            // 파일에서 읽은 DATA를 추후 결번 재전송을 위해 메모리에 저장해 둔다. 2008.06.19 - 정동한
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null) {
                block_data = new HashMap<Integer, byte[]>();
            }
            block_data.put( new Integer(SEQUENCE_NO-1), fileData);
            hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);
            // 2008.06.19 - 정동한

            this.batchDoc.getBatchMsg().getBody().setBlockNum(BLOCK_NO);
            this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // KED 모든 전문은 길이가 4000바이트로 고정되어 있으며 이를 SequenceSize 로 지정하기로 한다.
            SEND_LENGTH = batchDoc.getBatchMsg().getHeader().getSequenceSize();
            // X.25 이므로 아데나 장비용 길이 바이트를 추가
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }
//    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//        return super.getFieldValueString(5);
//    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
//    //업무관리코드 필드값 리턴
//    public String getOpCode()
//    {
//        return super.getFieldValueString(10);
//    }
}

